searchNodes=[{"doc":"File handling for MO ( .mo ) files.","ref":"Expo.MO.html","title":"Expo.MO","type":"module"},{"doc":"Composes a MO ( .mo ) file from the given messages . Examples iex&gt; % Expo.Messages { ...&gt; headers : [ &quot;Last-Translator: Jane Doe&quot; ] , ...&gt; messages : [ ...&gt; % Expo.Message.Singular { msgid : [ &quot;foo&quot; ] , msgstr : [ &quot;bar&quot; ] , comments : &quot;A comment&quot; } ...&gt; ] ...&gt; } ...&gt; |&gt; Expo.MO . compose ( ) ...&gt; |&gt; IO . iodata_to_binary ( ) &lt;&lt; 222 , 18 , 4 , 149 , 0 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 28 , 0 , 0 , 0 , 44 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 60 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 60 , 0 , 0 , 0 , 3 , 0 , 0 , 0 , 61 , 0 , 0 , 0 , 25 , 0 , 0 , 0 , 65 , 0 , 0 , 0 , 3 , 0 , 0 , 0 , 91 , 0 , 0 , 0 , 0 , 102 , 111 , 111 , 0 , 76 , 97 , 115 , 116 , 45 , 84 , 114 , 97 , 110 , 115 , 108 , 97 , 116 , 111 , 114 , 58 , 32 , 74 , 97 , 110 , 101 , 32 , 68 , 111 , 101 , 0 , 98 , 97 , 114 , 0 &gt;&gt;","ref":"Expo.MO.html#compose/2","title":"Expo.MO.compose/2","type":"function"},{"doc":"Parses a string into a Expo.Messages struct, raising an exception if there are any errors. Works exactly like parse_binary/1 , but returns a Expo.Messages struct if there are no errors or raises an exception if there are. Examples iex&gt; Expo.MO . parse_binary! ( &lt;&lt; ...&gt; 0xDE120495 :: size ( 4 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 2 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 2 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 28 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 28 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 28 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) ...&gt; &gt;&gt; ) % Expo.Messages { headers : [ ] , messages : [ ] } iex&gt; Expo.MO . parse_binary! ( &quot;invalid&quot; ) ** (Expo.MO.InvalidFileError) invalid file","ref":"Expo.MO.html#parse_binary!/2","title":"Expo.MO.parse_binary!/2","type":"function"},{"doc":"Parses the given binary as an MO file. If successful, returns {:ok, messages} where messages is a Expo.Messages struct. If there's an error, {:error, error} is returned where error is an exception struct. Examples iex&gt; Expo.MO . parse_binary ( &lt;&lt; ...&gt; 0xDE120495 :: size ( 4 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 2 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 2 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 28 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 28 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 28 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) , ...&gt; 0 :: little - unsigned - integer - size ( 4 ) - unit ( 8 ) ...&gt; &gt;&gt; ) { :ok , % Expo.Messages { headers : [ ] , messages : [ ] } }","ref":"Expo.MO.html#parse_binary/2","title":"Expo.MO.parse_binary/2","type":"function"},{"doc":"Parses the contents of a file into a Expo.Messages struct, raising if there are any errors. Works like parse_file/1 , except that it raises an exception if there's an error with parsing the file or a File.Error error if there's an error with reading the file. Examples Expo.MO . parse_file! ( &quot;nonexistent.po&quot; ) #=&gt; ** (File.Error) could not parse &quot;nonexistent.po&quot;: no such file or directory","ref":"Expo.MO.html#parse_file!/2","title":"Expo.MO.parse_file!/2","type":"function"},{"doc":"Parses the contents of the given file into a Expo.Messages struct. This function works similarly to parse_binary/1 except that it takes a file and parses the contents of that file as an MO file. It can return: {:ok, po} if the parsing is successful {:error, line, reason} if there is an error with the contents of the .mo file (for example, a syntax error) {:error, reason} if there is an error with reading the file (this error is one of the errors that can be returned by File.read/1 ) Examples { :ok , po } = Expo.MO . parse_file ( &quot;messages.po&quot; ) po . file #=&gt; &quot;messages.po&quot; Expo.MO . parse_file ( &quot;nonexistent&quot; ) #=&gt; {:error, :enoent}","ref":"Expo.MO.html#parse_file/2","title":"Expo.MO.parse_file/2","type":"function"},{"doc":"","ref":"Expo.MO.html#t:compose_option/0","title":"Expo.MO.compose_option/0","type":"type"},{"doc":"","ref":"Expo.MO.html#t:parse_option/0","title":"Expo.MO.parse_option/0","type":"type"},{"doc":"Functions to work on message structs ( Expo.Message.Singular and Expo.Message.Plural ). A message is a single PO message. For example: ` ` ` msgid &quot;Hello&quot; msgstr &quot;&quot; ` ` ` Message structs are used both to represent reference messages (where the msgstr is empty) in POT files as well as actual translations.","ref":"Expo.Message.html","title":"Expo.Message","type":"module"},{"doc":"Appends the given flag to the given message . Keeps the line formatting intact. Examples iex&gt; message = % Expo.Message.Singular { msgid : [ ] , flags : [ ] } iex&gt; Expo.Message . append_flag ( message , &quot;foo&quot; ) % Expo.Message.Singular { msgid : [ ] , flags : [ [ &quot;foo&quot; ] ] }","ref":"Expo.Message.html#append_flag/2","title":"Expo.Message.append_flag/2","type":"function"},{"doc":"Tells whether the given message has the given flag specified. Examples iex&gt; Expo.Message . has_flag? ( % Expo.Message.Singular { msgid : [ ] , flags : [ [ &quot;foo&quot; ] ] } , &quot;foo&quot; ) true iex&gt; Expo.Message . has_flag? ( % Expo.Message.Singular { msgid : [ ] , flags : [ [ &quot;foo&quot; ] ] } , &quot;bar&quot; ) false","ref":"Expo.Message.html#has_flag?/2","title":"Expo.Message.has_flag?/2","type":"function"},{"doc":"Returns a &quot;key&quot; that can be used to identify a message. This function returns a &quot;key&quot; that can be used to uniquely identify a message assuming that no &quot;same&quot; messages exist; for what &quot;same&quot; means, look at the documentation for same?/2 . The purpose of this function is to be used in situations where we'd like to group or sort messages but where we don't need the whole structs. Examples iex&gt; t1 = % Expo.Message.Singular { msgid : [ &quot;foo&quot; ] } iex&gt; t2 = % Expo.Message.Singular { msgid : [ &quot;&quot; , &quot;foo&quot; ] } iex&gt; Expo.Message . key ( t1 ) == Expo.Message . key ( t2 ) true iex&gt; t1 = % Expo.Message.Singular { msgid : [ &quot;foo&quot; ] } iex&gt; t2 = % Expo.Message.Singular { msgid : [ &quot;bar&quot; ] } iex&gt; Expo.Message . key ( t1 ) == Expo.Message . key ( t2 ) false","ref":"Expo.Message.html#key/1","title":"Expo.Message.key/1","type":"function"},{"doc":"Tells whether two messages are the same message according to their msgid . This function returns true if message1 and message2 are the same message, where &quot;the same&quot; means they have the same msgid or the same msgid and msgid_plural . Examples iex&gt; t1 = % Expo.Message.Singular { msgid : [ &quot;foo&quot; ] } iex&gt; t2 = % Expo.Message.Singular { msgid : [ &quot;&quot; , &quot;foo&quot; ] } iex&gt; Expo.Message . same? ( t1 , t2 ) true iex&gt; t1 = % Expo.Message.Singular { msgid : [ &quot;foo&quot; ] } iex&gt; t2 = % Expo.Message.Singular { msgid : [ &quot;bar&quot; ] } iex&gt; Expo.Message . same? ( t1 , t2 ) false","ref":"Expo.Message.html#same?/2","title":"Expo.Message.same?/2","type":"function"},{"doc":"Get the source line number of the message. Examples iex&gt; % Expo.Messages { messages : [ message ] } = Expo.PO . parse_string! ( &quot;&quot;&quot; ...&gt; msgid &quot;foo&quot; ...&gt; msgstr &quot;bar&quot; ...&gt; &quot;&quot;&quot; ) iex&gt; Expo.Message . source_line_number ( message , :msgid ) 1","ref":"Expo.Message.html#source_line_number/3","title":"Expo.Message.source_line_number/3","type":"function"},{"doc":"The key that can be used to identify a message. See key/1 .","ref":"Expo.Message.html#t:key/0","title":"Expo.Message.key/0","type":"opaque"},{"doc":"","ref":"Expo.Message.html#t:msgctxt/0","title":"Expo.Message.msgctxt/0","type":"type"},{"doc":"","ref":"Expo.Message.html#t:msgid/0","title":"Expo.Message.msgid/0","type":"type"},{"doc":"","ref":"Expo.Message.html#t:msgstr/0","title":"Expo.Message.msgstr/0","type":"type"},{"doc":"","ref":"Expo.Message.html#t:t/0","title":"Expo.Message.t/0","type":"type"},{"doc":"Struct for plural messages. For example: ` ` ` msgid &quot;Cat&quot; msgid_plural &quot;Cats&quot; msgstr &quot;&quot; ` ` ` All fields in this struct are public except for :__meta__ . The :flags and :references fields are defined as lists of lists in order to represent lines in the original file. For example, this message: ` ` ` #, flag1, flag2 #, flag3 #: a.ex:1 #: b.ex:2 c.ex:3 msgid &quot;Hello&quot; msgstr &quot;&quot; ` ` ` would have: flags: [[&quot;flag1&quot;, &quot;flag2&quot;], [&quot;flag3&quot;]] references: [[&quot;a.ex:1&quot;], [&quot;b.ex:2&quot;, &quot;c.ex:3&quot;]] You can use Expo.Message.has_flag?/2 to make it easier to check whether a message has a given flag.","ref":"Expo.Message.Plural.html","title":"Expo.Message.Plural","type":"module"},{"doc":"Rebalances all strings Put one string per newline of msgid / msgid_plural / msgstr Put all flags onto one line Put all references onto a separate line Examples iex&gt; Expo.Message.Plural . rebalance ( % Expo.Message.Plural { ...&gt; msgid : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] , ...&gt; msgid_plural : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] , ...&gt; msgstr : %{ 0 =&gt; [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] } , ...&gt; flags : [ [ &quot;one&quot; , &quot;two&quot; ] , [ &quot;three&quot; ] ] , ...&gt; references : [ [ { &quot;one&quot; , 1 } , { &quot;two&quot; , 2 } ] , [ &quot;three&quot; ] ] ...&gt; } ) % Plural { msgid : [ &quot;hello \\n &quot; , &quot;world&quot; ] , msgid_plural : [ &quot;hello \\n &quot; , &quot;world&quot; ] , msgstr : %{ 0 =&gt; [ &quot;hello \\n &quot; , &quot;world&quot; ] } , flags : [ [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; ] ] , references : [ [ { &quot;one&quot; , 1 } ] , [ { &quot;two&quot; , 2 } ] , [ &quot;three&quot; ] ] }","ref":"Expo.Message.Plural.html#rebalance/1","title":"Expo.Message.Plural.rebalance/1","type":"function"},{"doc":"Get the source line number of the message. Examples iex&gt; % Expo.Messages { messages : [ message ] } = Expo.PO . parse_string! ( &quot;&quot;&quot; ...&gt; msgid &quot;foo&quot; ...&gt; msgid_plural &quot;foos&quot; ...&gt; msgstr[0] &quot;bar&quot; ...&gt; &quot;&quot;&quot; ) iex&gt; Expo.Message.Plural . source_line_number ( message , :msgid ) 1","ref":"Expo.Message.Plural.html#source_line_number/3","title":"Expo.Message.Plural.source_line_number/3","type":"function"},{"doc":"","ref":"Expo.Message.Plural.html#t:block/0","title":"Expo.Message.Plural.block/0","type":"type"},{"doc":"","ref":"Expo.Message.Plural.html#t:meta/0","title":"Expo.Message.Plural.meta/0","type":"opaque"},{"doc":"","ref":"Expo.Message.Plural.html#t:t/0","title":"Expo.Message.Plural.t/0","type":"type"},{"doc":"Struct for non-plural messages. For example: ` ` ` msgid &quot;Hello&quot; msgstr &quot;&quot; ` ` ` All fields in this struct are public except for :__meta__ . The :flags and :references fields are defined as lists of lists in order to represent lines in the original file. For example, this message: ` ` ` #, flag1, flag2 #, flag3 #: a.ex:1 #: b.ex:2 c.ex:3 msgid &quot;Hello&quot; msgstr &quot;&quot; ` ` ` would have: flags: [[&quot;flag1&quot;, &quot;flag2&quot;], [&quot;flag3&quot;]] references: [[&quot;a.ex:1&quot;], [&quot;b.ex:2&quot;, &quot;c.ex:3&quot;]] You can use Expo.Message.has_flag?/2 to make it easier to check whether a message has a given flag.","ref":"Expo.Message.Singular.html","title":"Expo.Message.Singular","type":"module"},{"doc":"","ref":"Expo.Message.Singular.html#key/1","title":"Expo.Message.Singular.key/1","type":"function"},{"doc":"Rebalances all strings Put one string per newline of msgid / msgstr Put all flags onto one line Put all references onto a separate line Examples iex&gt; Expo.Message.Singular . rebalance ( % Expo.Message.Singular { ...&gt; msgid : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] , ...&gt; msgstr : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] , ...&gt; flags : [ [ &quot;one&quot; , &quot;two&quot; ] , [ &quot;three&quot; ] ] , ...&gt; references : [ [ { &quot;one&quot; , 1 } , { &quot;two&quot; , 2 } ] , [ &quot;three&quot; ] ] ...&gt; } ) % Singular { msgid : [ &quot;hello \\n &quot; , &quot;world&quot; ] , msgstr : [ &quot;hello \\n &quot; , &quot;world&quot; ] , flags : [ [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; ] ] , references : [ [ { &quot;one&quot; , 1 } ] , [ { &quot;two&quot; , 2 } ] , [ &quot;three&quot; ] ] }","ref":"Expo.Message.Singular.html#rebalance/1","title":"Expo.Message.Singular.rebalance/1","type":"function"},{"doc":"Get the source line number of the message. Examples iex&gt; % Expo.Messages { messages : [ message ] } = Expo.PO . parse_string! ( &quot;&quot;&quot; ...&gt; msgid &quot;foo&quot; ...&gt; msgstr &quot;bar&quot; ...&gt; &quot;&quot;&quot; ) iex&gt; Expo.Message.Singular . source_line_number ( message , :msgid ) 1","ref":"Expo.Message.Singular.html#source_line_number/3","title":"Expo.Message.Singular.source_line_number/3","type":"function"},{"doc":"","ref":"Expo.Message.Singular.html#t:block/0","title":"Expo.Message.Singular.block/0","type":"type"},{"doc":"","ref":"Expo.Message.Singular.html#t:meta/0","title":"Expo.Message.Singular.meta/0","type":"opaque"},{"doc":"","ref":"Expo.Message.Singular.html#t:t/0","title":"Expo.Message.Singular.t/0","type":"type"},{"doc":"A struct that represents lists of Expo.Message.Singular and Expo.Message.Plural structs for MO and PO files. All fields in the struct are public. See t/0 .","ref":"Expo.Messages.html","title":"Expo.Messages","type":"module"},{"doc":"Finds a given message_to_find in a list of messages . Equality between messages is checked using Expo.Message.same?/2 . Returns nil if message_to_find is not found.","ref":"Expo.Messages.html#find/2","title":"Expo.Messages.find/2","type":"function"},{"doc":"Get header by name (case insensitive). Examples iex&gt; messages = % Expo.Messages { headers : [ &quot;Language: en_US \\n &quot; ] , messages : [ ] } iex&gt; Expo.Messages . get_header ( messages , &quot;language&quot; ) [ &quot;en_US&quot; ] iex&gt; messages = % Expo.Messages { headers : [ &quot;Language: en_US \\n &quot; ] , messages : [ ] } iex&gt; Expo.Messages . get_header ( messages , &quot;invalid&quot; ) [ ]","ref":"Expo.Messages.html#get_header/2","title":"Expo.Messages.get_header/2","type":"function"},{"doc":"Rebalances all strings. All headers (see Expo.Message.Singular.rebalance/1 and Expo.Message.Plural.rebalance/1 ) Put one string per newline of headers and add one empty line at start Examples iex&gt; Expo.Messages . rebalance ( % Expo.Messages { ...&gt; headers : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] , ...&gt; messages : [ % Expo.Message.Singular { ...&gt; msgid : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] , ...&gt; msgstr : [ &quot;&quot; , &quot;hello&quot; , &quot; \\n &quot; , &quot;&quot; , &quot;world&quot; , &quot;&quot; ] ...&gt; } ] ...&gt; } ) % Expo.Messages { headers : [ &quot;&quot; , &quot;hello \\n &quot; , &quot;world&quot; ] , messages : [ % Expo.Message.Singular { msgid : [ &quot;hello \\n &quot; , &quot;world&quot; ] , msgstr : [ &quot;hello \\n &quot; , &quot;world&quot; ] } ] }","ref":"Expo.Messages.html#rebalance/1","title":"Expo.Messages.rebalance/1","type":"function"},{"doc":"","ref":"Expo.Messages.html#t:t/0","title":"Expo.Messages.t/0","type":"type"},{"doc":"File handling for PO ( .po ) and POT ( .pot ) files.","ref":"Expo.PO.html","title":"Expo.PO","type":"module"},{"doc":"Dumps a Expo.Messages struct as iodata. This function dumps a Expo.Messages struct (representing a PO file) as iodata, which can later be written to a file or converted to a string with IO.iodata_to_binary/1 . Examples After running the following code: iodata = Expo.PO . compose ( % Expo.Messages { headers : [ &quot;Last-Translator: Jane Doe&quot; ] , messages : [ % Expo.Message.Singular { msgid : [ &quot;foo&quot; ] , msgstr : [ &quot;bar&quot; ] , comments : &quot;A comment&quot; } ] } ) File . write! ( &quot;/tmp/test.po&quot; , iodata ) the /tmp/test.po file would look like this: msgid &quot;&quot; msgstr &quot;&quot; &quot;Last-Translator: Jane Doe&quot; # A comment msgid &quot;foo&quot; msgstr &quot;bar&quot;","ref":"Expo.PO.html#compose/1","title":"Expo.PO.compose/1","type":"function"},{"doc":"Parses the contents of a file into a Expo.Messages struct, raising if there are any errors. Works like parse_file/1 , except that it raises an exception if there are issues with the contents of the file or with reading the file. Examples Expo.PO . parse_file! ( &quot;nonexistent.po&quot; ) #=&gt; ** (File.Error) could not parse &quot;nonexistent.po&quot;: no such file or directory","ref":"Expo.PO.html#parse_file!/2","title":"Expo.PO.parse_file!/2","type":"function"},{"doc":"Parses the contents of a file into a Expo.Messages struct. This function works similarly to parse_string/1 except that it takes a file and parses the contents of that file. It can return: {:ok, po} if the parsing is successful {:error, error} if there is an error with the contents of the .po file (for example, a syntax error); error is an exception struct {:error, reason} if there is an error with reading the file (this error is one of the errors that can be returned by File.read/1 ) Examples { :ok , po } = Expo.PO . parse_file ( &quot;messages.po&quot; ) po . file #=&gt; &quot;messages.po&quot; Expo.PO . parse_file ( &quot;nonexistent&quot; ) #=&gt; {:error, :enoent}","ref":"Expo.PO.html#parse_file/2","title":"Expo.PO.parse_file/2","type":"function"},{"doc":"Parses string into a Expo.Messages struct, raising an exception if there are any errors. Works exactly like parse_string/1 , but returns a Expo.Messages struct if there are no errors or raises an exception if there are. Examples iex&gt; po = Expo.PO . parse_string! ( &quot;&quot;&quot; ...&gt; msgid &quot;foo&quot; ...&gt; msgstr &quot;bar&quot; ...&gt; &quot;&quot;&quot; ) iex&gt; [ message ] = po . messages iex&gt; message . msgid [ &quot;foo&quot; ] iex&gt; message . msgstr [ &quot;bar&quot; ] iex&gt; po . headers [ ] iex&gt; Expo.PO . parse_string! ( &quot;msgid&quot; ) ** (Expo.PO.SyntaxError) 1: no space after &#39;msgid&#39; iex&gt; Expo.PO . parse_string! ( &quot;&quot;&quot; ...&gt; msgid &quot;test&quot; ...&gt; msgstr &quot;&quot; ...&gt; ...&gt; msgid &quot;test&quot; ...&gt; msgstr &quot;&quot; ...&gt; &quot;&quot;&quot; ) ** (Expo.PO.DuplicateMessagesError) 4: found duplicate on line 4 for msgid: &#39;test&#39;","ref":"Expo.PO.html#parse_string!/2","title":"Expo.PO.parse_string!/2","type":"function"},{"doc":"Parses the given string into a Expo.Messages struct. It returns {:ok, messages} if there are no errors, otherwise {:error, error} where error is an exception struct. Examples iex&gt; { :ok , po } = Expo.PO . parse_string ( &quot;&quot;&quot; ...&gt; msgid &quot;foo&quot; ...&gt; msgstr &quot;bar&quot; ...&gt; &quot;&quot;&quot; ) iex&gt; [ message ] = po . messages iex&gt; message . msgid [ &quot;foo&quot; ] iex&gt; message . msgstr [ &quot;bar&quot; ] iex&gt; po . headers [ ] iex&gt; Expo.PO . parse_string ( &quot;foo&quot; ) { :error , % Expo.PO.SyntaxError { line : 1 , reason : &quot;unknown keyword &#39;foo&#39;&quot; } }","ref":"Expo.PO.html#parse_string/2","title":"Expo.PO.parse_string/2","type":"function"},{"doc":"","ref":"Expo.PO.html#t:parse_option/0","title":"Expo.PO.parse_option/0","type":"type"},{"doc":"Functions to parse and evaluate plural forms as defined in the GNU Gettext documentation. The documentation is available at https://www.gnu.org/software/gettext/manual/html_node/Plural-forms.html . Usage Some functions in this module are considered &quot;low level&quot;, and are meant to be used by other libraries. For example, parse/1 returns an expression that is not really meant to be inspected, but rather used internally by this library.","ref":"Expo.PluralForms.html","title":"Expo.PluralForms","type":"module"},{"doc":"Gets the plural form for the given number based on the given plural_forms struct. Examples iex&gt; { :ok , plural_form } = Expo.PluralForms . parse ( &quot;nplurals=2; plural=n != 1;&quot; ) iex&gt; Expo.PluralForms . index ( plural_form , 4 ) 1 iex&gt; Expo.PluralForms . index ( plural_form , 1 ) 0","ref":"Expo.PluralForms.html#index/2","title":"Expo.PluralForms.index/2","type":"function"},{"doc":"Get known locales where plural form information is available. Examples iex&gt; &quot;de&quot; in Expo.PluralForms . known_locales ( ) true iex&gt; &quot;invalid&quot; in Expo.PluralForms . known_locales ( ) false","ref":"Expo.PluralForms.html#known_locales/0","title":"Expo.PluralForms.known_locales/0","type":"function"},{"doc":"Parses a plural forms string into a t/0 struct, raising if there are errors. Same as parse/1 , but returns the plural forms struct directly if the parsing is successful, or raises an error otherwise. The Inspect implementation for the Expo.PluralForms struct uses this function to display the plural forms expression, which is why the example below might look a bit weird. Examples iex&gt; Expo.PluralForms . parse! ( &quot;nplurals=2; plural=n != 1;&quot; ) Expo.PluralForms . parse! ( &quot;nplurals=2; plural=n != 1;&quot; )","ref":"Expo.PluralForms.html#parse!/1","title":"Expo.PluralForms.parse!/1","type":"function"},{"doc":"Parses a plural forms string into a t/0 struct. Returns {:ok, struct} if the string is valid, or {:error, error} if it isn't. Examples iex&gt; Expo.PluralForms . parse ( &quot;nplurals=2; plural=n != 1;&quot; ) { :ok , Expo.PluralForms . parse! ( &quot;nplurals=2; plural=n != 1;&quot; ) }","ref":"Expo.PluralForms.html#parse/1","title":"Expo.PluralForms.parse/1","type":"function"},{"doc":"Gets the plural form for the given language based on built-in information. Examples iex&gt; Expo.PluralForms . plural_form ( &quot;de&quot; ) { :ok , Expo.PluralForms . parse! ( &quot;nplurals=2; plural=(n != 1);&quot; ) } iex&gt; Expo.PluralForms . plural_form ( &quot;invalid&quot; ) :error","ref":"Expo.PluralForms.html#plural_form/1","title":"Expo.PluralForms.plural_form/1","type":"function"},{"doc":"Converts a plural forms struct into its string representation. Examples iex&gt; plural_forms = Expo.PluralForms . parse! ( &quot;nplurals=2; plural=n != 1;&quot; ) iex&gt; Expo.PluralForms . to_string ( plural_forms ) &quot;nplurals=2; plural=n != 1;&quot;","ref":"Expo.PluralForms.html#to_string/1","title":"Expo.PluralForms.to_string/1","type":"function"},{"doc":"The AST of a plural forms expression. This is evaluated internally to determine the plural form for a given number using index/2 , and is not meant to be inspected directly.","ref":"Expo.PluralForms.html#t:plural_ast/0","title":"Expo.PluralForms.plural_ast/0","type":"opaque"},{"doc":"A struct representing a plural forms expression.","ref":"Expo.PluralForms.html#t:t/0","title":"Expo.PluralForms.t/0","type":"type"},{"doc":"Generate binary message catalog from textual message description. mix expo . msgfmt [ PO_FILE ] [ OPTIONS ] Options --use-fuzzy - use fuzzy entries in output --endianness=BYTEORDER - write out 32-bit numbers in the given byte order (big or little, default depends on platform) --output-file=FILE - write output to specified file --statistics - print statistics about messages","ref":"Mix.Tasks.Expo.Msgfmt.html","title":"Mix.Tasks.Expo.Msgfmt","type":"task"},{"doc":"An error raised when the content does not follow the MO file structure. The fields of this exception are public.","ref":"Expo.MO.InvalidFileError.html","title":"Expo.MO.InvalidFileError","type":"exception"},{"doc":"","ref":"Expo.MO.InvalidFileError.html#t:t/0","title":"Expo.MO.InvalidFileError.t/0","type":"type"},{"doc":"An error returned when the version of the MO file is not supported. All the fields in this struct are public.","ref":"Expo.MO.UnsupportedVersionError.html","title":"Expo.MO.UnsupportedVersionError","type":"exception"},{"doc":"","ref":"Expo.MO.UnsupportedVersionError.html#t:t/0","title":"Expo.MO.UnsupportedVersionError.t/0","type":"type"},{"doc":"An error raised when duplicate messages are detected.","ref":"Expo.PO.DuplicateMessagesError.html","title":"Expo.PO.DuplicateMessagesError","type":"exception"},{"doc":"","ref":"Expo.PO.DuplicateMessagesError.html#t:t/0","title":"Expo.PO.DuplicateMessagesError.t/0","type":"type"},{"doc":"An error raised when the syntax in a PO file (a file ending in .po ) isn't correct.","ref":"Expo.PO.SyntaxError.html","title":"Expo.PO.SyntaxError","type":"exception"},{"doc":"","ref":"Expo.PO.SyntaxError.html#t:t/0","title":"Expo.PO.SyntaxError.t/0","type":"type"},{"doc":"An error raised when the syntax in a plural forms string is invalid.","ref":"Expo.PluralForms.SyntaxError.html","title":"Expo.PluralForms.SyntaxError","type":"exception"},{"doc":"","ref":"Expo.PluralForms.SyntaxError.html#t:t/0","title":"Expo.PluralForms.SyntaxError.t/0","type":"type"},{"doc":"Low-level GNU gettext file handling (for .po , .pot , and .mo files), including writing and parsing. See the documentation . For a full Gettext integration, see the Gettext library .","ref":"readme.html","title":"Expo","type":"extras"},{"doc":"Expo can parse PO, POT, and MO files from GNU gettext : Expo.PO . parse_file! ( &quot;priv/gettext/default.pot&quot; ) #=&gt; %Expo.Messages{...} It can also write well-formed PO, POT, and MO files: &quot;priv/gettext/default.pot&quot; |&gt; Expo.PO . parse_file! ( ) |&gt; Expo.PO . compose ( ) |&gt; then ( fn content -&gt; File . write! ( &quot;priv/gettext/copy.pot&quot; ) end ) This library can also parse Plural-Form headers in PO or POT files, and ships with a built-in list of languages and their plural forms. You can find which plural form to use for a given amount by using Expo.PluralForms.index/2 : { :ok , plural_form } = Expo.PluralForms . plural_form ( &quot;de&quot; ) Expo.PluralForms . index ( plural_form , 1 ) #=&gt; 0 Expo.PluralForms . index ( plural_form , 213 ) #=&gt; 1","ref":"readme.html#usage","title":"Expo - Usage","type":"extras"},{"doc":"Copyright 2015 Plataformatec Copyright 2020 Dashbit 2022 JOSHMARTIN GmbH Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at: http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Expo - License","type":"extras"}]